package Apache::lonsupportreq;

use strict;
use lib qw(/home/httpd/lib/perl);
use MIME::Types;
use MIME::Lite;
use Apache::Constants qw(:common);
use Apache::loncommon();
use Apache::lonnet();
use Apache::lonlocal;

sub handler {
    my ($r) = @_;
    &Apache::loncommon::content_type($r,'text/html');
    $r->send_http_header;

    if ($r->header_only) {
        return OK;
    }
    &Apache::loncommon::get_unprocessed_cgi($ENV{'QUERY_STRING'},['origurl','function']);
    if ($r->uri eq '/adm/helpdesk') {
        &Apache::loncommon::get_posted_cgi($r);
    }
    my $function = $ENV{'form.function'};
    my $origurl = &Apache::lonnet::unescape($ENV{'form.origurl'});
    my $action = $ENV{'form.action'};

    if ($action eq 'process') {
        &print_request_receipt($r,$origurl,$function);
    } else {
        &print_request_form($r,$origurl,$function);
    }
    return OK;
}
    
sub print_request_form {
    my ($r,$origurl,$function) = @_;
    my ($os,$browser,$bversion,$uhost,$uname,$udom,$uhome,$urole,$usec,$email,$cid,$cdom,$cnum,$ctitle,$ccode,$sectionlist,$lastname,$firstname,$server);
    my $bodytag = &Apache::loncommon::bodytag('',$function,'topmargin="0",marginheight="0"',1);
    my $tablecolor = &Apache::loncommon::designparm($function.'.tabbg');
    if (($tablecolor eq '') || ($tablecolor eq '#FFFFFF')) {
        $tablecolor = '#EEEE99';
    }
    $ccode = '';
    $os = $ENV{'browser.os'};
    $browser = $ENV{'browser.type'};
    $bversion = $ENV{'browser.version'};
    $uhost = $ENV{'request.host'};
    $uname = $ENV{'user.name'};
    $udom = $ENV{'user.domain'};
    $uhome = $ENV{'user.home'};
    $urole = $ENV{'request.role'};
    $usec = $ENV{'request.course.sec'};
    $cid = $ENV{'request.course.id'};
    $server = $ENV{'SERVER_NAME'};
    my $scripttag = (<<'END');
function validate() {
    if (validmail(document.logproblem.email) == false) {
        alert("The e-mail address you entered: "+document.logproblem.email.value+" is not a valid e-mail address.");
        return;
    }
    document.logproblem.submit();
}

function validmail(field) {
    var str = field.value;
    if (window.RegExp) {
        var reg1str = "(@.*@)|(\\.\\.)|(@\\.)|(\\.@)|(^\\.)";
        var reg2str = "^.+\\@(\\[?)[a-zA-Z0-9\\-\\.]+\\.([a-zA-Z]{2,3}|[0-9]{1,3})(\\]?)$";
        var reg1 = new RegExp(reg1str);
        var reg2 = new RegExp(reg2str);
        if (!reg1.test(str) && reg2.test(str)) {
            return true;
        }
        return false;
    }
    else
    {
        if(str.indexOf("@") >= 0) {
            return true;
        }
        return false;
    }
}
END
    if ($cid =~ m/_/) {
        ($cdom,$cnum) = split/_/,$cid;
    }
    if ($cdom && $cnum) {
        my %csettings = &Apache::lonnet::get('environment',['description','internal.coursecode','internal.sectionnums'],$cdom,$cnum);
        $ctitle = $csettings{'description'};
        $ccode = $csettings{'internal.coursecode'};
        $sectionlist = $csettings{'internal.sectionnums'};
    }
    if ($ENV{'environment.critnotification'}) {
        $email = $ENV{'environment.critnotification'};
    }
    if (!$email && $ENV{'environment.notification'}) {
        $email = $ENV{'environment.notification'};
    }
    if ($ENV{'environment.lastname'}) {
        $lastname = $ENV{'environment.lastname'};
    }
    if ($ENV{'environment.firstname'}) {
        $firstname = $ENV{'environment.firstname'};
    }
    my @sections = split/,/,$sectionlist;
    my %groupid = ();
    foreach (@sections) {
        my ($sec,$grp) = split/:/,$_;
        $groupid{$sec} = $grp;
    }
    my $defdom = $Apache::lonnet::perlvar{'lonDefDomain'};
    my $codedom = $defdom;
    my %coursecodes = ();
    my %codes = ();
    my @codetitles = ();
    my %cat_titles = ();
    my %cat_order = ();
    my %idlist = ();
    my %idnums = ();
    my %idlist_titles = ();
    my $caller = 'global';
    my $totcodes = 0;
    my $format_reply;
    my $jscript = '';
    
    if ($cdom) {
        $codedom = $cdom;
    }
    if ($cnum) {
        $coursecodes{$cnum} = $ccode;
        if ($ccode eq '') {
            $totcodes = &retrieve_instcodes(\%coursecodes,$codedom,$totcodes);
        } else {
            $coursecodes{$cnum} = $ccode;
            $caller = $cnum;
            $totcodes ++;
        }
    } else { 
        $totcodes = &retrieve_instcodes(\%coursecodes,$codedom,$totcodes);
    }
    if ($totcodes > 0) {
        $format_reply = &Apache::lonnet::auto_instcode_format($caller,$codedom,\%coursecodes,\%codes,\@codetitles,\%cat_titles,\%cat_order);
        if ($ccode eq '') {
            my $numtypes = @codetitles;
            &build_code_selections(\%codes,\@codetitles,\%cat_titles,\%cat_order,\%idlist,\%idnums,\%idlist_titles);
            &javascript_code_selections($numtypes,\$jscript,\%idlist,\%idnums,\%idlist_titles,\@codetitles);
        }
    }
    $r->print(<<ENDHEAD);
<html>
<head>
 <title>LON-CAPA support request</title>
<script type"text/javascript">
$scripttag
$jscript
</script>
</head>
$bodytag
ENDHEAD
    if ($r->uri eq '/adm/helpdesk') {
        &print_header($r,$origurl);
    }
    $r->print(<<"END");
<form method="post" name="logproblem" enctype="multipart/form-data">
 <table width="580" border="0" cellpadding="0" cellspacing="0" bgcolor="#000000">
  <tr>
   <td>
    <table width="100%" border="0" cellpadding="0" cellspacing="1" bgcolor="#000000">
     <tr>
      <td>
       <table width="100%" border="0" cellpadding="0" cellspacing="0" bgcolor="#ffffff">
        <tr>
         <td>
	  <table width="100%" border="0" cellpadding="0" cellspacing="1" bgcolor="#ffffff">
           <tr>
            <td width="140" bgcolor="$tablecolor">
             <table width="140" border="0" cellpadding="8" cellspacing="0">
              <tr>
               <td align="right"><b>Name:</b>
               </td>
              </tr>
             </table>
            </td>
            <td width="100%" valign="top">
             <table width="100%" border="0" cellpadding="8" cellspacing="0">
              <tr>
               <td>
END
    my $fullname = '';
    if ((defined($lastname) && $lastname ne '') && (defined($firstname) && $firstname ne '')) {
        $fullname = "$firstname $lastname"; 
        $r->print("$fullname<input type=\"hidden\" name=\"username\" value=\"$fullname\" />");
    } else {
        if (defined($firstname) && $firstname ne '') {
            $fullname = $firstname;
        } elsif (defined($lastname) && $lastname ne '') {
            $fullname= " $lastname";
        }
        $r->print('<input type="text" size="20" name="username" value="'.$fullname.'" />');
    }
    $r->print(<<END);
                &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type="button" value="Submit Request" onClick="validate()" />&nbsp;
               </td>
              </tr>
             </table>
            </td>
           </tr>
           <tr>
            <td width="100%" colspan="2" bgcolor="#000000">
             <img src="/adm/lonMisc/blackdot.gif" /><br />
            </td>
           </tr>
           <tr>
            <td width="140" bgcolor="$tablecolor">
             <table width="140" border="0" cellpadding="8" cellspacing="0">
              <tr>
               <td align="right"><b>E-mail address:</b>
               </td>
              </tr>
             </table>
            </td>
            <td width="100%" valign="top">
             <table width="100%" border="0" cellpadding="8" cellspacing="0">
              <tr>
               <td>
                <input type="text" size="20" name="email" value="$email" /><br />
               </td>
              </tr>
             </table>
            </td>
           </tr>
           <tr>
            <td width="100%" colspan="2" bgcolor="#000000">
             <img src="/adm/lonMisc/blackdot.gif" /><br />
            </td>
           </tr>
           <tr>
            <td width="140" bgcolor="$tablecolor">
             <table width="140" border="0" cellpadding="8" cellspacing="0">
              <tr>
               <td align="right"><b>username/domain:</b>
               </td>
              </tr>
             </table>
            </td>
            <td width="100%" valign="top">
             <table width="100%" border="0" cellpadding="8" cellspacing="0">
              <tr>
               <td>
END
    my $udom_input = '<input type="hidden" name="udom" value="'.$udom.'" />';
    my $uname_input = '<input type="hidden" name="uname" value="'.$uname.'" />'; 
    if (defined($uname) && defined($udom)) {
        $r->print('<i>username</i>:&nbsp;'.$uname.'&nbsp;&nbsp;<i>domain</i>:&nbsp;'.$udom.$udom_input.$uname_input);
    } else {
        my $udomform = '';
        my $unameform = '';
        if (defined($udom)) {
            $udomform = '<i>domain</i>:&nbsp;'.$udom.$udom_input;
        } elsif (defined($uname)) {
            $unameform = '<i>username</i>:&nbsp;'.$uname.'&nbsp;&nbsp;'.$uname_input;
        }
        if ($udomform eq '') {
            $udomform = '<i>domain</i>:&nbsp;';
            $udomform .= &Apache::loncommon::select_dom_form($defdom,'udom');
        }
        if ($unameform eq '') {
            $unameform= '<i>username</i>:&nbsp;<input type="text" size="20" name="loncname" value="'.$uname.'" />&nbsp;&nbsp;';
        }
        $r->print($unameform.$udomform.'<br />Enter the username you use to log-in to your LON-CAPA system, and choose your domain.');
    }
    $r->print(<<END);
               </td>
              </tr>
             </table>
            </td>
           </tr>
           <tr>
            <td width="100%" colspan="2" bgcolor="#000000">
             <img src="/adm/lonMisc/blackdot.gif" /><br />
            </td>
           </tr>
           <tr>
            <td width="140" bgcolor="$tablecolor">
             <table width="140" border="0" cellpadding="8" cellspacing="0">
              <tr>
               <td align="right"><b>URL of page:</b>
               </td>
              </tr>
             </table>
            </td>
            <td width="100%" valign="top">
             <table width="100%" border="0" cellpadding="8" cellspacing="0">
              <tr>
               <td>
                http://$server$origurl<input type="hidden" name="sourceurl" value="http://$server$origurl" />
               </td>
              </tr>
             </table>
            </td>
           </tr>
           <tr>
            <td width="100%" colspan="2" bgcolor="#000000">
             <img src="/adm/lonMisc/blackdot.gif" /><br />
            </td>
           </tr>
           <tr>
            <td width="140" bgcolor="$tablecolor">
             <table width="140" border="0" cellpadding="8" cellspacing="0">
              <tr>
               <td align="right"><b>Phone #:</b>
               </td>
              </tr>
             </table>
            </td>
            <td width="100%" valign="top">
             <table width="100%" border="0" cellpadding="8" cellspacing="0">
              <tr>
               <td>
                <input type="text" size="15" name="phone"><br>
               </td>
              </tr>
             </table>
            </td>
           </tr>
           <tr>
            <td width="100%" colspan="2" bgcolor="#000000">
             <img src="/adm/lonMisc/blackdot.gif" /><br />
            </td>
           </tr>
           <tr>
            <td width="140" bgcolor="$tablecolor">
             <table width="140" border="0" cellpadding="8" cellspacing="0">
              <tr>
               <td align="right"><b>Course Details:</b>
               </td>
              </tr>
             </table>
            </td>
            <td width="100%" valign="top">
             <table border="0" cellpadding="3" cellspacing="3">
              <tr>
               <td>
END
    if ($cnum) { 
        if ($coursecodes{$cnum}) {
            foreach (@codetitles) {
                $r->print('<i>'.$_.'</i>:&nbsp;'.$codes{$cnum}{$_}.';&nbsp;');
            }
            $r->print('&nbsp;<input type="hidden" name="coursecode" value="'.$coursecodes{$cnum}.'" />');
        } else {
            $r->print('Enter institutional course code:&nbsp;
                  <input type="text" name="coursecode" size="15" value="" />');
        }
    } else {
        if ($totcodes > 0) {
            my $numtitles = @codetitles;
            if ($numtitles == 0) {
                $r->print('Enter institutional course code:&nbsp;
                  <input type="text" name="coursecode" size="15" value="" />');
            } else {
                my $lasttitle = $numtitles;
                if ($numtitles > 4) {
                    $lasttitle = 4;
                } 
                $r->print('<table><tr><td>'.$codetitles[0].'<br />'."\n".
                      '<select name="'.$codetitles[0].'" onChange="courseSet('."'$codetitles[0]'".')">'."\n".
                      ' <option value="-1" />Select'."\n");
                my @items = ();
                if ($idlist{$codetitles[0]} =~ /","/) {
                    @items = split/","/,$idlist{$codetitles[0]};
                } else {
                    $items[0] = $idlist{$codetitles[0]};
                }
                foreach (@items) {
                    $r->print(' <option value="'.$_.'" />'.$_);
                }
                $r->print('</select></td>');
                for (my $i=1; $i<$numtitles; $i++) {
                    $r->print('<td>'.$codetitles[$i].'<br />'."\n".
                     '<select name="'.$codetitles[$i].'" onChange="courseSet('."'$codetitles[$i]'".')">'."\n".
                     '<option value="-1">&lt;-Pick '.$codetitles[$i-1].'</option>'."\n".
                     '</select>'."\n".
                     '</td>'
                    );
                }
                $r->print('</tr></table>');
                if ($numtitles > 4) {
                    $r->print('<br /><br />'.$codetitles[$numtitles].'<br />'."\n".
                          '<select name="'.$codetitles[$numtitles].'" onChange="courseSet('."'$codetitles[$numtitles]'".')">'."\n".
                          '<option value="-1">&lt;-Pick '.$codetitles[$numtitles-1].'</option>'."\n".
                          '</select>'."\n");
                }
            }
        } else {
            $r->print('Enter institutional course code:&nbsp;
                  <input type="text" name="coursecode" size="15" value="" />');
        }
    }
    if ($ctitle) {
        $r->print('<br /><i>Title</i>:&nbsp;'.$ctitle.'<input type="hidden" name="title" value="'.$ctitle.'" />');
    } else {
        $r->print('<br />Enter course title:&nbsp;
                 <input type="text" name="title" size="25" value="" />');
    }
    $r->print(<<END);
               </td>
              </tr>
             </table>
            </td>
           </tr>
           <tr>
            <td width="100%" colspan="2" bgcolor="#000000">
             <img src="/adm/lonMisc/blackdot.gif" /><br />
            </td>
           </tr>
           <tr>
            <td width="140" bgcolor="$tablecolor">
             <table width="140" border="0" cellpadding="8" cellspacing="0">
              <tr>
               <td align="right"><b>Section Number: </b>
               </td>
              </tr>
             </table>
            </td>
            <td width="100%" valign="top">
             <table width="100%" border="0" cellpadding="8" cellspacing="0">
              <tr>
               <td>
END
    if ($sectionlist) {
        $r->print("<select name=\"section\">");
        foreach (sort keys %groupid) {
            if ($_ eq $groupid{$_} || $groupid{$_} eq '') {
                $r->print("<option value=\"$_\" />$_");
            } else {
                $r->print("<option value=\"$_\" />$_ - (LON-CAPA sec: $groupid{$_})");
            }
        }
        $r->print("</select>");
    } else {
        $r->print("<input type=\"text\" name=\"section\" size=\"10\"/>");
    }
    $r->print(<<END);
               </td>
              </tr>
             </table>
            </td>
           </tr>
           <tr>
            <td width="100%" colspan="2" bgcolor="#000000">
             <img src="/adm/lonMisc/blackdot.gif" /><br />
            </td>
           </tr>
           <tr>
            <td width="140" bgcolor="$tablecolor">
             <table width="140" border="0" cellpadding="8" cellspacing="0">
              <tr>
               <td align="right"><b>Subject</b>
               </td>
              </tr>
             </table>
            </td>
            <td width="100%" valign="top">
             <table width="100%" border="0" cellpadding="8" cellspacing="0">
              <tr>
               <td>
                <input type="text" size="40" name="subject">
               </td>
              </tr>
             </table>
            </td>
           </tr>
           <tr>
            <td width="100%" colspan="2" bgcolor="#000000">
             <img src="/adm/lonMisc/blackdot.gif" /><br />
            </td>
           </tr>
           <tr>
            <td width="140" bgcolor="$tablecolor">
             <table width="140" border="0" cellpadding="8" cellspacing="0">
              <tr>
               <td align="right"><b>Detailed description:</b>
               </td>
              </tr>
             </table>
            </td>
            <td width="100%" valign="top">
             <table width="100%" border="0" cellpadding="8" cellspacing="0">
              <tr>
               <td>
                <textarea rows="10" cols="45" name="description" wrap="virtual"></textarea>
               </td>
              </tr>
             </table>
            </td>
           </tr>
           <tr>
	    <td width="100%" colspan="2" bgcolor="#000000">
             <img src="/adm/lonMisc/blackdot.gif" /><br />
	    </td>
	   </tr>
END
    if (defined($ENV{'user.name'})) {
        $r->print(<<END);
           <tr>
            <td width="140" bgcolor="$tablecolor">
             <table width="140" border="0" cellpadding="8" cellspacing="0">
              <tr>
               <td align="right"><b>Optional file upload:</b>
               </td>
              </tr>
             </table>
            </td>
            <td width="100%" valign="top">
             <table width="100%" border="0" cellpadding="8" cellspacing="0">
              <tr>
               <td>
                <input type="file" name="screenshot" size="20" /><br />Upload a file (e.g., a screenshot) relevant to your support request (128 KB max. size).
               </td>
              </tr>
             </table>
            </td>
           </tr>
           <tr>
            <td width="100%" colspan="2" bgcolor="#000000">
             <img src="/adm/lonMisc/blackdot.gif" /><br />
            </td>
           </tr>
END
    }
    $r->print(<<END);
           <tr>
            <td width="140" bgcolor="$tablecolor">
             <table width="140" border="0" cellpadding="8" cellspacing="0">
              <tr>
               <td align="right"><b>Finish:</b>
               </td>
              </tr>
             </table>
            </td>
            <td width="100%" valign="top">
             <table border="0" cellpadding="8" cellspacing="0">
              <tr>
               <td>
                <input type="hidden" name="action" value="process" />
                <input type="button" value="Submit Request" onClick="validate()"/> &nbsp;
               </td>
               <td>&nbsp;</td>
               <td>
                <input type="reset" value="Clear Form">
               </td>
              </tr>
             </table>
            </td>
           </tr>
          </table>
         </td>
        </tr>
       </table>
      </td>
     </tr>
    </table>
   </td>
  </tr>
 </table>
</form>
</body>
</html>
END
    return;
}

sub print_request_receipt {
    my ($r,$url,$function) = @_;
    my @envvars = ('lonID','HTTP_HOST','HTTP_USER_AGENT','REMOTE_ADDR','SERVER_ADDR','SERVER_NAME','browser.os','browser.type','browser.version','user.home','request.role');
    my @loncvars = ('user.name','user.domain','request.course.sec','request.course.id');

    my $bodytag = &Apache::loncommon::bodytag('',$function,'topmargin="0" marginheight="0"',1);
    my $admin = $Apache::lonnet::perlvar{'lonAdminMail'};
    my $to =  $Apache::lonnet::perlvar{'lonSupportEMail'};
    my $from = $admin;
    my $reporttime = &Apache::lonlocal::locallocaltime(time);
    my $fontcolor = &Apache::loncommon::designparm($function.'.font');
    my $vlinkcolor = &Apache::loncommon::designparm($function.'.vlink');
    my $tablecolor = &Apache::loncommon::designparm($function.'.tabbg');
    my @formvars = ('username','email','uname','udom','sourceurl','phone','section','coursecode','title','subject','description','screenshot');
    &Apache::loncommon::get_unprocessed_cgi($ENV{'QUERY_STRING'},\@formvars);

    my $supportmsg = qq|
Name: $ENV{'form.username'}
Email: $ENV{'form.email'}
Username/domain: $ENV{'form.uname'} - $ENV{'form.udom'}
Tel: $ENV{'form.phone'}
Course Information: $ENV{'form.title'} - $ENV{'form.coursecode'} - section: $ENV{'form.section'}
Subject: $ENV{'form.subject'}
Description: $ENV{'form.description'}
URL: $ENV{'form.sourceurl'}
Date/Time: $reporttime

    |;
    my $descrip = $ENV{'form.description'};
    $descrip =~ s#\n#<br />#g;
    my $displaymsg = qq|
<font color="$fontcolor">Name:</font><font color="$vlinkcolor"> $ENV{'form.username'}</font><br />
<font color="$fontcolor">Email: </font><font color="$vlinkcolor">$ENV{'form.email'}</font><br />
<font color="$fontcolor">Username/domain: </font><font color="$vlinkcolor">$ENV{'form.uname'} - $ENV{'form.udom'}</font><br />
<font color="$fontcolor">Tel: </font><font color="$vlinkcolor">$ENV{'form.phone'}</font><br />
<font color="$fontcolor">Course Information: </font><font color="$vlinkcolor">$ENV{'form.title'} - $ENV{'form.coursecode'} - section: $ENV{'form.section'}</font><br />
<font color="$fontcolor">Subject: </font><font color="$vlinkcolor">$ENV{'form.subject'}</font><br />
<font color="$fontcolor">Description: </font><font color="$vlinkcolor">$descrip</font><br />
<font color="$fontcolor">URL: </font><font color="$vlinkcolor">$ENV{'form.sourceurl'}</font><br />
<font color="$fontcolor">Date/Time: </font><font color="$vlinkcolor">$reporttime</font><br />
    |;
    $r->print(<<"END");
<html>
<head>
 <title>LON-CAPA support request recorded</title>
</head>
$bodytag
<form name="logproblem">
<input type="hidden" name="action" value="result" />
</form>
END
    if ($r->uri eq '/adm/helpdesk') {
        &print_header($r,$url,'process');
    }
    if ($to =~ m/^[^\@]+\@[^\@]+$/) {
        $r->print("<h3>A support request has been sent to $to</h3>");
    } else {
        $to = $admin;
        if ($to =~ m/^[^\@]+\@[^\@]+$/) {
            $r->print("<h3>A support request has been sent to $to</h3>");
END
        } else {
            $r->print(<<END);
 <h3>Warning: Problem with support e-mail address</h3>
As the e-mail address provided for this LON-CAPA server ($to) does not appear to be a valid e-mail address, your support request has <b>not</b> been sent to the LON-CAPA support staff or administrator at your institution. Instead a copy has been sent to the LON-CAPA support team at Michigan State University. 
END
            $to = 'helpdesk@lon-capa.org';
        }
    }
    if (defined($ENV{'form.email'})) {
        if ($ENV{'form.email'} =~ m/^[^\@]+\@[^\@]+$/) {
            $from = $ENV{'form.email'};
        }
    }

    my $subject = $ENV{'form.subject'};
    $subject =~ s#(`)#'#g;
    $subject =~ s#\$#\(\$\)#g;
    $supportmsg =~ s#(`)#'#g;
    $supportmsg =~ s#\$#\(\$\)#g;
    $displaymsg =~ s#(`)#'#g;
    $displaymsg =~ s#\$#\(\$\)#g;
    my $fname;

    my $attachmentpath = '';
    my $attachmentsize = '';
    if (defined($ENV{'user.name'})) {
        if ($ENV{'form.screenshot.filename'}) {
            $attachmentsize = length($ENV{'form.screenshot'});
            if ($attachmentsize > 131072) {
                $displaymsg .= "<br />The uploaded screenshot file ($attachmentsize bytes) included with your request exceeded the maximum allowed size - 128 KB, and has therefore been discarded.";
            } else {
                $attachmentpath=&Apache::lonnet::userfileupload('screenshot',undef,'helprequests');
            }
        }
    }

    if ($attachmentpath =~ m-/([^/]+)$-) {
        $fname = $1;
        $displaymsg .= "<br />An uploaded screenshot file - $fname ($attachmentsize bytes) was included in the request sent by $ENV{'user.name'} from LON-CAPA domain: $ENV{'user.domain'}";
        $supportmsg .= "\n";
        foreach (@envvars) {
            $supportmsg .= "$_: $ENV{$_}\n";
        }
    }
 
    my $msg = MIME::Lite->new(
                 From    => $from,
                 To      => $to,
                 Subject => $subject,
                 Type    =>'TEXT',
                 Data    => $supportmsg,
                 );

    if ($attachmentpath) {
        my ($type, $encoding) = MIME::Types::by_suffix($attachmentpath);
        $msg->attach(Type     => $type,
                     Path     => $attachmentpath,
                     Filename => $fname
                     );

    } else {
        my $envdata = '';
        foreach (@envvars) {
            $envdata .= "$_: $ENV{$_}\n";
        }
        foreach (@loncvars) {
            $envdata .= "$_: $ENV{$_}\n";
        }
        $msg->attach(Type => 'TEXT',
                     Data => $envdata);
    }

### Send it:
    # ->send can cause an sh launch which can pass all of %ENV along
    # which can be to large for /bin/sh's little mind
    my %oldENV=%ENV;
    undef(%ENV);
    $msg->send('sendmail');
    %ENV=%oldENV;
    undef(%oldENV);

    if ($attachmentpath =~ m#$Apache::lonnet::perlvar{'lonDaemons'}/tmp/helprequests/(\d+)/[^/]+#) {
        unlink($attachmentpath);
    }
    $r->print(qq|
 <b>Your support request contained the following information</b>:<br /><br />
 <table width="580" border="0" cellpadding="0" cellspacing="0" bgcolor="#000000">
  <tr>
   <td>
    <table width="100%" border="0" cellpadding="0" cellspacing="1" bgcolor="#000000">
     <tr>
      <td>
       <table width="100%" border="0" cellpadding="0" cellspacing="0" bgcolor="#ffffff">
        <tr>
         <td>
          <table width="100%" border="0" cellpadding="0" cellspacing="1" bgcolor="#ffffff">
           <tr>
            <td width="140" bgcolor="$tablecolor">
             <table width="140" border="0" cellpadding="8" cellspacing="0">
              <tr>
               <td align="right"><b>Information supplied</b>
               </td>
              </tr>
             </table>
            </td>
            <td width="100%" valign="top">
             <table width="100%" border="0" cellpadding="8" cellspacing="0">
              <tr>
               <td>$displaymsg</td>
              </tr>
             </table>
            </td>
           </tr>
           <tr>
            <td width="100%" colspan="2" bgcolor="#000000">
             <img src="/adm/lonMisc/blackdot.gif" /><br />
            </td>
           </tr>
           <tr>
            <td width="140" bgcolor="$tablecolor">
             <table width="140" border="0" cellpadding="8" cellspacing="0">
              <tr>
               <td align="right"><b>Additional information recorded</b>
               </td>
              </tr>
             </table>
            </td>
            <td width="100%" valign="top">
             <table width="100%" border="0" cellpadding="8" cellspacing="0">
              <tr>
               <td>
    |);
    foreach (@envvars) {
        unless($ENV{$_} eq '') { 
            $r->print("$_:&nbsp;<font color='$vlinkcolor'>$ENV{$_}</font>, ");
        }
    }
    $r->print("
               </td>
              </tr>
             </table>
            </td>
           </tr>
          </table>
         </td>
        </tr>
       </table>
      </td>
     </tr>
    </table>
   </td>
  </tr>
 </table>
</body>
</html>
    ");
}

sub print_header {
    my ($r,$origurl,$action) = @_;
    my $location=&Apache::loncommon::lonhttpdurl("/adm");
    my $tablecolor = '#EEEE99';
    my ($component_url);
    my $helpdesk_link = '<a href="javascript:validate()">';
    if ($action eq 'process') {
        $helpdesk_link = '<a href="/adm/helpdesk">';
    }
    my %lt = &Apache::lonlocal::texthash (
                                           login => 'Log-in help',
                                           ask   => 'Ask helpdesk',
                                           getst => 'Getting started guide',
                                           back =>  'Back to last location'
                                         );  
    $r->print(<<END);
<table width="620" border="0" cellspacing="0" cellpadding="0" height="55">   <tr height="50">    <td width='5'>&nbsp;</td>
   <td>
    <fieldset><legend><img src="$location/lonIcons/minilogo.gif" height='20' width='29' valign='bottom' />&nbsp;&nbsp;<b><font size="+1">LON-CAPA help/support</font></b></legend>
 <table width="100%" border="0" cellpadding="0" cellspacing="0" bgcolor="#000000">
  <tr>
   <td>
    <table width="100%" border="0" cellpadding="0" cellspacing="1" bgcolor="#000000">
     <tr>
      <td>
       <table width="100%" border="0" cellpadding="0" cellspacing="0" bgcolor="#ffffff">
        <tr>
         <td>
          <table width="100%" border="0" cellpadding="0" cellspacing="1" bgcolor="#ffffff">
           <tr bgcolor="$tablecolor">
            <td align="center"><img src="$location/help/gif/smallHelp.gif" border="0" alt="(Login help)" valign="middle" />&nbsp;<b><a href="/adm/loginproblems.html">$lt{'login'}</a></td>
            <td align="center">&nbsp;<b>$helpdesk_link<img src="$location/lonIcons/helpdesk.gif" border="0" alt="(Ask helpdesk)" valign="middle" />&nbsp;$lt{'ask'}</a></b>&nbsp;</td>
            <td align="center">&nbsp;<b><a href="/adm/gettingstarted.html">$lt{'getst'}</a></td>
            <td align="center">&nbsp;<b><a href="$origurl" target="_top"><img src="$location/lonIcons/move_up.gif" border="0" alt="(Back to last location)" valign="middle" />&nbsp;$lt{'back'}</a></b>&nbsp;</td>
           </tr>
          </table>
         </td>
        </tr>
       </table>
      </td>
     </tr>
    </table>
   </td>
  </tr>
 </table>
</fieldset>
  </td>
  <td width='5'>&nbsp;</td>
 </tr>
 <tr height='5'>
  <td colspan='3' height='5'>&nbsp;</td>
 </tr>
END
    unless ($action eq 'process') {
        $r->print('
 <tr>
  <td colspan="3">'.&mt('
Please read the "Log-in help" and "Getting started guide" if you can not log-in').'.  '.&mt('If your problem is still unresolved, the form below can be used to send a question to the LON-CAPA helpdesk').'.<br /><font size="-1"><b>'.&mt('Note').':</b> '.&mt('Student questions about course content should be directed to the course instructor').'.</font><br /><br />
  </td>
 </tr>');
    }
    $r->print('
</table>');
    return;
}

sub retrieve_instcodes {
    my ($coursecodes,$codedom,$totcodes) = @_;
    my %courses = &Apache::lonnet::courseiddump($codedom,'.',1,'.','.');
    foreach my $course (keys %courses) {
        if ($courses{$course} =~ m/^[^:]*:([^:]+)/) {
            $$coursecodes{$course} = &Apache::lonnet::unescape($1);
            $totcodes ++;
        }
    }
    return $totcodes;
}

sub build_code_selections {
    my ($codes,$codetitles,$cat_titles,$cat_order,$idlist,$idnums,$idlist_titles) = @_;
    my %idarrays = ();
    for (my $i=1; $i<@{$codetitles}; $i++) {
        %{$idarrays{$$codetitles[$i]}} = ();
    }
    foreach my $cid (sort keys %{$codes}) {
        &recurse_list($cid,$codetitles,$codes,0,\%idarrays);
    }
    for (my $num=0; $num<@{$codetitles}; $num++) {
        if ($num == 0) {
            my @contents = ();
            my @contents_titles = ();
            &sort_cats($num,$cat_order,$codetitles,\@{$idarrays{$$codetitles[0]}},\@contents);
            if (defined($$cat_titles{$$codetitles[0]})) {
                foreach (@contents) {
                    push @contents_titles, $$cat_titles{$$codetitles[0]}{$_};
                }
            }
            $$idlist{$$codetitles[0]} = join('","',@contents);
            $$idnums{$$codetitles[0]} = scalar(@contents);
            if (defined($$cat_titles{$$codetitles[0]})) {
                $$idlist_titles{$$codetitles[0]} = join('","',@contents_titles);
            }
        } elsif ($num == 1) {
            %{$$idlist{$$codetitles[1]}} = ();
            %{$$idlist_titles{$$codetitles[1]}} = ();
            foreach my $key_a (keys %{$idarrays{$$codetitles[1]}}) {
                my @sorted_a = ();
                my @sorted_a_titles = ();
                &sort_cats($num,$cat_order,$codetitles,\@{$idarrays{$$codetitles[1]}{$key_a}},\@sorted_a);
                if (defined($$cat_titles{$$codetitles[1]})) {
                    foreach (@sorted_a) {
                        push @sorted_a_titles, $$cat_titles{$$codetitles[1]}{$_};
                    }
                }
                $$idlist{$$codetitles[1]}{$key_a} = join('","',@sorted_a);
                $$idnums{$$codetitles[1]}{$key_a} = scalar(@sorted_a);
                if (defined($$cat_titles{$$codetitles[1]})) {
                    $$idlist_titles{$$codetitles[1]}{$key_a} = join('","',@sorted_a_titles);
                }
            }
        } elsif ($num == 2) {
            %{$$idlist{$$codetitles[2]}} = ();
            %{$$idlist_titles{$$codetitles[2]}} = ();
            foreach my $key_a (keys %{$idarrays{$$codetitles[2]}}) {
                %{$$idlist{$$codetitles[2]}{$key_a}} = ();
                %{$$idlist_titles{$$codetitles[2]}{$key_a}} = ();
                foreach my $key_b (keys %{$idarrays{$$codetitles[2]}{$key_a}}) {
                    my @sorted_b = ();
                    my @sorted_b_titles = ();
                    &sort_cats($num,$cat_order,$codetitles,\@{$idarrays{$$codetitles[2]}{$key_a}{$key_b}},\@sorted_b);
                    if (defined($$cat_titles{$$codetitles[1]})) {
                        foreach (@sorted_b) {
                            push @sorted_b_titles, $$cat_titles{$$codetitles[1]}{$_};
                        }
                    }
                    $$idlist{$$codetitles[2]}{$key_a}{$key_b} = join('","',@sorted_b);
                    $$idnums{$$codetitles[2]}{$key_a}{$key_b} = scalar(@sorted_b);
                    if (defined($$cat_titles{$$codetitles[2]})) {
                        $$idlist_titles{$$codetitles[2]}{$key_a}{$key_b} = join('","',@sorted_b_titles);
                    }
                }
            }
        } elsif ($num == 3) {
            %{$$idlist{$$codetitles[3]}} = ();
            foreach my $key_a (keys %{$idarrays{$$codetitles[3]}}) {
                %{$$idlist{$$codetitles[3]}{$key_a}} = ();
                foreach my $key_b (keys %{$idarrays{$$codetitles[3]}{$key_a}}) {
                    %{$$idlist{$$codetitles[3]}{$key_a}{$key_b}} = ();
                    foreach my $key_c (keys %{$idarrays{$$codetitles[3]}{$key_a}{$key_b}}) {
                        my @sorted_c = ();
                        &sort_cats($num,$cat_order,$codetitles,\@{$idarrays{$$codetitles[3]}{$key_a}{$key_b}{$key_c}},\@sorted_c);
                        $$idlist{$$codetitles[3]}{$key_a}{$key_b}{$key_c} = join('","',@sorted_c);
                        $$idnums{$$codetitles[3]}{$key_a}{$key_b}{$key_c} = scalar(@sorted_c);
                    }
                }
            }
        } elsif ($num == 4) {
            %{$$idlist{$$codetitles[4]}} = ();
            foreach my $key_a (keys %{$idarrays{$$codetitles[4]}}) {
                %{$$idlist{$$codetitles[4]}{$key_a}} = ();
                foreach my $key_b (keys %{$idarrays{$$codetitles[4]}{$key_a}}) {
                    %{$$idlist{$$codetitles[4]}{$key_a}{$key_b}} = ();
                    foreach my $key_c (keys %{$idarrays{$$codetitles[4]}{$key_a}{$key_b}}) {
                        %{$$idlist{$$codetitles[4]}{$key_a}{$key_b}{$key_c}} = ();
                        foreach my $key_d (keys %{$idarrays{$$codetitles[4]}{$key_a}{$key_b}{$key_c}}) {
                            my @sorted_d = ();
                            &sort_cats($num,$cat_order,$codetitles,$idarrays{$$codetitles[4]}{$key_a}{$key_b}{$key_c}{$key_d},\@sorted_d);
                            $$idlist{$$codetitles[4]}{$key_a}{$key_b}{$key_c}{$key_d} = join('","',@sorted_d);
                            $$idnums{$$codetitles[4]}{$key_a}{$key_b}{$key_c}{$key_d} = scalar(@sorted_d);
                        }
                    }
                }
            }
        }
    }
}

sub sort_cats {
    my ($num,$cat_order,$codetitles,$idsarrayref,$sorted) = @_;
    my @unsorted = @{$idsarrayref};
    if (defined($$cat_order{$$codetitles[$num]})) {
        foreach (@{$$cat_order{$$codetitles[$num]}}) {
            if (grep/^$_$/,@unsorted) {
                push @{$sorted}, $_;
            }
        }
    } else {
        @{$sorted} = sort (@unsorted);
    }
}


sub recurse_list {
    my ($cid,$codetitles,$codes,$num,$idarrays) = @_;
    if ($num == 0) {
        if (!grep/^$$codes{$cid}{$$codetitles[0]}$/,@{$$idarrays{$$codetitles[0]}}) {
            push @{$$idarrays{$$codetitles[0]}}, $$codes{$cid}{$$codetitles[0]};
        }
    } elsif ($num == 1) {
        if (defined($$idarrays{$$codetitles[1]}{$$codes{$cid}{$$codetitles[0]}})) {
            if (!grep/^$$codes{$cid}{$$codetitles[1]}$/,@{$$idarrays{$$codetitles[1]}{$$codes{$cid}{$$codetitles[0]}}}) {
                push @{$$idarrays{$$codetitles[1]}{$$codes{$cid}{$$codetitles[0]}}}, $$codes{$cid}{$$codetitles[1]};
            }
        } else {
            @{$$idarrays{$$codetitles[1]}{$$codes{$cid}{$$codetitles[0]}}} = ("$$codes{$cid}{$$codetitles[1]}");
        }
    } elsif ($num == 2) {
        if (defined($$idarrays{$$codetitles[2]}{$$codes{$cid}{$$codetitles[0]}})) {
            if (defined($$idarrays{$$codetitles[2]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}})) {
                if (!grep/^$$codes{$cid}{$$codetitles[2]}$/,@{$$idarrays{$$codetitles[2]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}}}) {
                    push @{$$idarrays{$$codetitles[2]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}}}, $$codes{$cid}{$$codetitles[2]};
                }
            } else {
                @{$$idarrays{$$codetitles[2]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}}} = ("$$codes{$cid}{$$codetitles[2]}");
            }
        } else {
            %{$$idarrays{$$codetitles[2]}{$$codes{$cid}{$$codetitles[0]}}} = ();
            @{$$idarrays{$$codetitles[2]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}}} = ("$$codes{$cid}{$$codetitles[2]}");
        }
    } elsif ($num == 3) {
        if (defined($$idarrays{$$codetitles[3]}{$$codes{$cid}{$$codetitles[0]}})) {
            if (defined($$idarrays{$$codetitles[3]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}})) {
                if (defined($$idarrays{$$codetitles[3]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}}{$$codes{$cid}{$$codetitles[2]}})) {
                    if (!grep/^$$codes{$cid}{$$codetitles[3]}$/,@{$$idarrays{$$codetitles[3]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}}{$$codes{$cid}{$$codetitles[2]}}}) {
                        push @{$$idarrays{$$codetitles[3]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}}{$$codes{$cid}{$$codetitles[2]}}}, $$codes{$cid}{$$codetitles[3]};
                    }
                } else {
                    @{$$idarrays{$$codetitles[3]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}}{$$codes{$cid}{$$codetitles[2]}}} = ("$$codes{$cid}{$$codetitles[3]}");
                }
            } else {
                %{$$idarrays{$$codetitles[3]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}}} = ();
                @{$$idarrays{$$codetitles[3]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}}{$$codes{$cid}{$$codetitles[2]}}} = ("$$codes{$cid}{$$codetitles[3]}");
            }
        } else {
            %{$$idarrays{$$codetitles[3]}{$$codes{$cid}{$$codetitles[0]}}} = ();
            %{$$idarrays{$$codetitles[3]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}}} = ();
            @{$$idarrays{$$codetitles[3]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}}{$$codes{$cid}{$$codetitles[2]}}} = ("$$codes{$cid}{$$codetitles[3]}");
        }
    } elsif ($num == 4) {
        if (defined($$idarrays{$$codetitles[4]}{$$codes{$cid}{$$codetitles[0]}})) {
            if (defined($$idarrays{$$codetitles[4]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}})) {
                if (defined($$idarrays{$$codetitles[4]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}}{$$codes{$cid}{$$codetitles[2]}})) {
                    if (defined($$idarrays{$$codetitles[4]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}}{$$codes{$cid}{$$codetitles[2]}}{$$codes{$cid}{$$codetitles[3]}})) {
                        if (!grep/^$$codes{$cid}{$$codetitles[4]}$/,@{$$idarrays{$$codetitles[4]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}}{$$codes{$cid}{$$codetitles[2]}}{$$codes{$cid}{$$codetitles[3]}}}) {
                            push @{$$idarrays{$$codetitles[4]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}}{$$codes{$cid}{$$codetitles[2]}}{$$codes{$cid}{$$codetitles[3]}}}, $$codes{$cid}{$$codetitles[4]};
                        }
                    } else {
                        @{$$idarrays{$$codetitles[4]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}}{$$codes{$cid}{$$codetitles[2]}}{$$codes{$cid}{$$codetitles[3]}}} = ("$$codes{$cid}{$$codetitles[4]}");
                    }
                } else {
                    %{$$idarrays{$$codetitles[4]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}}{$$codes{$cid}{$$codetitles[2]}}} = ();
                    @{$$idarrays{$$codetitles[4]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}}{$$codes{$cid}{$$codetitles[2]}}{$$codes{$cid}{$$codetitles[3]}}} = ("$$codes{$cid}{$$codetitles[4]}");
                }
            } else {
                %{$$idarrays{$$codetitles[4]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}}} = ();
                %{$$idarrays{$$codetitles[4]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}}{$$codes{$cid}{$$codetitles[2]}}} = ();
                @{$$idarrays{$$codetitles[4]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}}{$$codes{$cid}{$$codetitles[2]}}{$$codes{$cid}{$$codetitles[3]}}} = ("$$codes{$cid}{$$codetitles[4]}");
            }
        } else {
            %{$$idarrays{$$codetitles[4]}{$$codes{$cid}{$$codetitles[0]}}} = ();
            %{$$idarrays{$$codetitles[4]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}}} = ();
            %{$$idarrays{$$codetitles[4]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}}{$$codes{$cid}{$$codetitles[2]}}} = ();
            @{$$idarrays{$$codetitles[4]}{$$codes{$cid}{$$codetitles[0]}}{$$codes{$cid}{$$codetitles[1]}}{$$codes{$cid}{$$codetitles[1]}}{$$codes{$cid}{$$codetitles[3]}}} = ("$$codes{$cid}{$$codetitles[3]}");
        }
    }
    $num ++;
    if ($num <@{$codetitles}) {
        &recurse_list($cid,$codetitles,$codes,$num,$idarrays);
    }
}

sub javascript_code_selections {
    my ($numcats,$script_tag,$idlist,$idnums,$idlist_titles,$codetitles) = @_;
    my $numtitles = @{$codetitles};
    my @seltitles = (); 
    for (my $j=0; $j<$numtitles; $j++) {
        $seltitles[$j] = 'id'.$$codetitles[$j];
    }
    my $seltitle_str = join('","',@seltitles);
    $$script_tag .= <<END;
function courseSet(caller) {
    var ids = new Array ("$seltitle_str");
    var formitems = new Array ($numtitles);
    var idyr = document.logproblem.Year.selectedIndex
    var idsem  = document.logproblem.Semester.selectedIndex
    var iddept = document.logproblem.Department.selectedIndex
    var idclass = document.logproblem.Number.selectedIndex
    var idyears = new Array("$$idlist{$$codetitles[0]}");
    var idsems = new Array ($$idnums{$$codetitles[0]});
    var idsemlongs = new Array ($$idnums{$$codetitles[0]});
    var idcodes = new Array ($$idnums{$$codetitles[0]});
    var idcourses = new Array ($$idnums{$$codetitles[0]});
END
    my @sort_a = split/","/,$$idlist{$$codetitles[0]}; 
    for (my $j=0; $j<@sort_a; $j++) {
        $$script_tag .= qq| idsems[$j] = new Array("$$idlist{$$codetitles[1]}{$sort_a[$j]}")\n|;
        $$script_tag .= qq| idsemlongs[$j] = new Array("$$idlist_titles{$$codetitles[1]}{$sort_a[$j]}")\n|;
        $$script_tag .= qq| idcodes[$j] = new Array($$idnums{$$codetitles[1]}{$sort_a[$j]})\n|;
        $$script_tag .= qq| idcourses[$j] = new Array($$idnums{$$codetitles[1]}{$sort_a[$j]})\n|;
        my @sort_b = split/","/,$$idlist{$$codetitles[1]}{$sort_a[$j]};
        for (my $k=0; $k<@sort_b; $k++) {
            my $idcode_entry = $$idlist{$$codetitles[2]}{$sort_a[$j]}{$sort_b[$k]};
            $$script_tag .= qq| idcodes[$j][$k] = new Array("$idcode_entry")\n|;
            $$script_tag .= qq| idcourses[$j][$k] = new Array($$idnums{$$codetitles[2]}{$sort_a[$j]}{$sort_b[$k]})\n|;
            my @sort_c = split/","/,$$idlist{$$codetitles[2]}{$sort_a[$j]}{$sort_b[$k]};
            for (my $l=0; $l<@sort_c; $l++) {
                my $idcourse_entry = $$idlist{$$codetitles[3]}{$sort_a[$j]}{$sort_b[$k]}{$sort_c[$l]};
                $$script_tag .= qq| idcourses[$j][$k][$l] = new Array("$idcourse_entry")\n|;
            }
        }
    }
    $$script_tag .= (<<END_OF_BLOCK);
 if (caller == "Year") {
   document.logproblem.Department.length = 0
   document.logproblem.Number.length = 0
   document.logproblem.Department.options[0] = new Option("<-Pick Semester.","-1",true,true)
   document.logproblem.Number.options[0] = new Option("<-Pick Department","-1",true,true)
   if (idyr == 0) {
    document.logproblem.Semester.length = 0
    document.logproblem.Semester.options[0] = new Option("<-Pick Year","-1",true,true)
   }
   else {
    document.logproblem.Semester.length = 0
    document.logproblem.Semester.options[0] = new Option("Select","-1",true,true)
    for (var i=0; i<idsems[idyr-1].length; i++) {
      document.logproblem.Semester.options[i+1] = new Option(idsemlongs[idyr-1][i],idsems[idyr-1][i],false,false)
    }
   }
   document.logproblem.Semester.selectedIndex = 0;
 }
 if (caller == "Semester") {
   document.logproblem.Department.length = 0
   document.logproblem.Number.length = 0
   document.logproblem.Number.options[0] = new Option("<-Pick Department.","-1",true,true)
   if (idsem == 0) {
     document.logproblem.Department.options[0] = new Option("<-Pick Semester.","-1",true,true)
     document.logproblem.Department.options[0] = new Option("<-Pick Semester","-1",true,true)
   }
   else {
    document.logproblem.Department.options[0] = new Option("Select","-1",true,true)    
    for (var i=0; i<idcodes[idyr-1][idsem-1].length; i++) {
      document.logproblem.Department.options[i+1] = new Option(idcodes[idyr-1][idsem-1][i],idcodes[idyr-1][idsem-1][i],false,false)
    }
   }
   document.logproblem.Department.selectedIndex = 0
 }
 if (caller == "Department") {
   document.logproblem.Number.length = 0
   if (iddept == 0) {
     document.logproblem.Number.options[0] = new Option("<-Pick Department.","-1",true,true)
   }
   else {
    document.logproblem.Number.options[0] = new Option("Select","-1",true,true)
    for (var i=0; i<idcourses[idyr-1][idsem-1][iddept-1].length; i++) {
      document.logproblem.Number.options[i+1] = new Option(idcourses[idyr-1][idsem-1][iddept-1][i],idcourses[idyr-1][idsem-1][iddept-1][i],false,false)
    }
   }
   document.logproblem.Number.selectedIndex = 0
 }
}
END_OF_BLOCK
}

1;
